#include "StdAfx.h"
#include "MemoDropTarget.h"
#include "NoteModel.h"
#include "InfoUserMgrWnd.h"
#include "NeMessengerDlg.h"
#include "main_frame.hpp"


MemoDropTarget::MemoDropTarget(CNoteModel* pModel)
: m_pNoteModel(pModel)
{
	m_clipboardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));
}

MemoDropTarget::~MemoDropTarget(void)
{
}

BOOL MemoDropTarget::OnDrop( CWnd* pWnd, COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point )
{
	try
	{	
		if (pDataObject->IsDataAvailable(m_clipboardFormat))
		{
			CFile* pFile = pDataObject->GetFileData(m_clipboardFormat);
			if (pFile == NULL)
			{
				return TRUE;
			}
			//CArchive ar(pFile, CArchive::load); 
			int nCount = -1;
			std::vector<const IGTBuddyUser *> buddyVector;
            if (eFavoriteTab == GET_MESSENGER_DLG()->GetMainFrame()->GetCurrentTabSelect())
            {
                GET_MESSENGER_DLG()->GetMainFrame()->GetSelectedBuddyItems(buddyVector);
                nCount = buddyVector.size();
				if(!CheckMaxUser(pWnd, nCount))
				{
					for (int i = 0; i < nCount; ++i)
					{
						/*CNtalkDragData dropUser;
						dropUser.Serialize(ar);*/
						const IGTBuddyUser *dropUser = buddyVector.at(i);
						//޴  ߺ ƴҶ. ߰
						if(m_pNoteModel->AddNoteReceiver(dropUser->GetUserID(), dropUser->GetName()))
						{
							if (pWnd && pWnd->GetSafeHwnd())
								pWnd->SendMessage(UM_USERMGR_ADDUSER, (WPARAM)0, (LPARAM)dropUser);
						}
					}

				}
            }
			else if (eOrganizationTab == GET_MESSENGER_DLG()->GetMainFrame()->GetCurrentTabSelect())
			{
				std::vector<Node*> OrgBuddyVector;
				GET_MESSENGER_DLG()->GetMainFrame()->GetSelectedOrgItems(OrgBuddyVector);
				nCount = OrgBuddyVector.size();
				if(!CheckMaxUser(pWnd, nCount))
				{
					for (int i = 0; i < nCount; ++i)
					{					
						if (!OrgBuddyVector[i]->folder() &&!OrgBuddyVector[i]->IsRoot() )
						{
							CNtalkDragData dropUser;
							dropUser.m_strID = OrgBuddyVector[i]->data().value;
							dropUser.m_strName = OrgBuddyVector[i]->data().text_; 
							if(m_pNoteModel->AddNoteReceiver(dropUser.m_strID, dropUser.m_strName))
							{
								if (pWnd && pWnd->GetSafeHwnd())
									pWnd->SendMessage(UM_USERMGR_ADDORGUSER, (WPARAM)0, (LPARAM)&dropUser);
							}
						}

					}

				}
			}

		//	ar.Close();
			delete pFile;
			return TRUE;
		}
	}
	catch (...)
	{
		return FALSE;
	}

	return COleDropTarget::OnDrop(pWnd, pDataObject, dropEffect, point);
}

DROPEFFECT MemoDropTarget::OnDragEnter( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	return GetDropEffect(pDataObject);
}

DROPEFFECT MemoDropTarget::OnDragOver( CWnd* pWnd, COleDataObject* pDataObject, DWORD dwKeyState, CPoint point )
{
	return GetDropEffect(pDataObject);
}

DROPEFFECT MemoDropTarget::GetDropEffect( COleDataObject* pDataObject )
{
	DROPEFFECT dropEffect = DROPEFFECT_NONE;

	if (pDataObject->IsDataAvailable(m_clipboardFormat))
	{
		dropEffect = DROPEFFECT_COPY;
	}

	return dropEffect;
}

bool MemoDropTarget::CheckMaxUser(CWnd* pWnd, int nCount ) 
{
	bool bRet=false;
	LRESULT res = m_pNoteModel->IsEnableReceiverUserCount(m_pNoteModel->GetCurrentReceiverCount() + nCount);
	if(res != 0L)
	{
		if (pWnd && pWnd->GetSafeHwnd())
			pWnd->SendMessage(UM_USERMGR_ADDMAXUSER, (WPARAM)0, (LPARAM)res);
		bRet=true;
	}
	return bRet;
}
